jQuery(document).ready(function($) {

	wpcc_url 			= $('.wpcc_url').val();
	
	function wpcc_sum(str, fid) {
		var str_replace = str.replace( /[^0-9.()+-\/*%^]/g, '' );
		var str_eval = eval(str_replace);
		return str_eval;
	}
	
	function wpcc_fn_action(value, fid, wpcc_id) {
		$('.wpcc_jq_if').each(function() {
			var if_id 			= $(this).data('if_id');
			var if_operator 	= $(this).data('operator');
			var if_val 			= String($(this).data('val'));
			var if_show_id		= $(this).data('show');
			var if_hide_id		= $(this).data('hide');
			var if_logic		= $(this).data('logic');
			if(if_id == fid)
			{
				wpcc_jq_if_check_condition(value, if_val, if_operator, if_show_id, if_hide_id, if_logic, wpcc_id);
			}
		});
	}
	
	/* Fields Action */
	$.fn.wpcc_field_action = function() {
		$(this).each(function() {
			var this_form 		= $(this).closest('.wpcc_form');
			var wpcc_id 		= $('.wpcc_id', this_form).val();
			var type 			= $(this).data('type');
			var fid 			= $(this).data('fid');
			field_value 		= '';
			
			if(type == 'inputtext')
			{	
				$(this).keyup( function()
				{
					var field_val = $(this).val();					
					if(field_val == '')
					{
						field_value =  $(this).data('default');
					}
					else
					{
						field_value = field_val;
					}
					var this_action		= $(this).data('action');
					var this_price		= $(this).data('price');
					var this_sum		= wpcc_sum(field_value+this_action+this_price, fid);
					wpcc_fn_action(this_sum, fid, wpcc_id);
				});
			}
			else if(type == 'custom_fields')
			{	
				$(this).keyup( function()
				{
					var field_val = $(this).val();					
					if(field_val == '')
					{
						field_value =  $(this).data('default');
					}
					else
					{
						field_value = field_value;
					}
					wpcc_fn_action(field_value, fid, wpcc_id);
				});
			}
			else if(type == 'select')
			{
				$(this).change( function()
				{
					wpcc_fn_action($(this).val(), fid, wpcc_id);
				});
			}
			else if(type == 'radio')
			{
				$(this).click( function()
				{
					wpcc_fn_action($(this).val(), fid, wpcc_id);
				});
			}
			else if(type == 'checkbox')
			{
				var this_action = $(this).data('action');
				var this_prop 	= {};
				$('input', $(this)).each(function()
				{
					$(this).click( function()
					{
						if($(this).prop("checked"))
						{
							this_prop[$(this).data('i')] = $(this).val();
						}
						else
						{
							delete this_prop[$(this).data('i')];
						}
						var this_out = []; 
						for (var this_key in this_prop) {
							this_out.push(this_prop[this_key]); 
						}
						var field_value = wpcc_sum(this_out.join(this_action), fid);
						wpcc_fn_action(field_value, fid, wpcc_id);
					});
				});
				
			}
			else if(type == 'slider')
			{
				/* view fn.wpcc_slider callback STOP */
			}
		});
		//console.log(wpcc_data);
	};
	$('.wpcc_jq_action').wpcc_field_action();
	
	/* If Change */
	$.fn.wpcc_jq_if_change = function(ids, fn, wpcc_id) {
		ids_string = String(ids);
		if(ids_string.length > 0) {
			var this_check_arr_show	= ids_string.indexOf(",");
			
			if(this_check_arr_show >= '0')
			{
				var this_show_arr 	= ids_string.split(",");
				for (i = 0; i < this_show_arr.length; i++ ) {
					if(fn == 'show')
					{
						$('.wpcc_form_' + wpcc_id + ' .wpcc_box_' + this_show_arr[i]).show();
					}
					else if(fn == 'hide')
					{
						$('.wpcc_form_' + wpcc_id + ' .wpcc_box_' + this_show_arr[i]).hide();
					}
				}
			}
			else
			{
				if(fn == 'show')
				{
					$('.wpcc_form_' + wpcc_id + ' .wpcc_box_' + ids_string).show();
				}
				else if(fn == 'hide')
				{
					$('.wpcc_form_' + wpcc_id + ' .wpcc_box_' + ids_string).hide();
				}
			}
		}
	};
	
	/* Сondition */
	function wpcc_jq_if_check_condition (value, if_val, operator, s, h, if_logic, wpcc_id) {
		var this_type = $(this).data('type');
		
		if(this_type == 'checkbox')
		{
			var for_checked = $(this).prop("checked");
		}
		else
		{
			var for_checked = true;
		}
		if(operator != '==' && operator != 'between')
		{
			var value 	= value - 0;
			var if_val 	= if_val - 0;
		}
		
		if(operator == 'between')
		{
			var if_value_between 		= if_val.split("-");
			var if_value_between_one 	= if_value_between[0];
			var if_value_between_two 	= if_value_between[1];
			var value 					= value - 0;
		}
		if(
			( operator == '==' && ( for_checked && value == if_val ) )
			||
			( operator == '>=' && ( for_checked && value >= if_val ) )
			||
			( operator == '<=' && ( for_checked && value <= if_val ) )
			||
			( operator == '>' && ( for_checked && value > if_val ) )
			||
			( operator == '<' && ( for_checked && value < if_val ) )
			||
			( operator == 'between' && ( for_checked && value >= if_value_between_one && value <= if_value_between_two ) )
		)
		{
			$(this).wpcc_jq_if_change(s, 'show', wpcc_id);
			$(this).wpcc_jq_if_change(h, 'hide', wpcc_id);
		}
		else
		{
			if(if_logic != 'if')
			{
				$(this).wpcc_jq_if_change(s, 'hide', wpcc_id);
				$(this).wpcc_jq_if_change(h, 'show', wpcc_id);
			}
		}
	}
	
	/* Slider */
	$.fn.wpcc_slider = function () {
		$(this).each(function() {
			var this_sl  	= $(this);
			var this_parent	= this_sl.closest('.wpcc_box');
			var this_form 	= this_sl.closest('.wpcc_form');
			var wpcc_id 	= $('.wpcc_id', this_form).val();
			
			var fid   = this_sl.data('fid');
			var sl_va = $(this).data('value');
			var sl_mi = $(this).data('min');
			var sl_ma = $(this).data('max');
			var sl_st = $(this).data('step');
			var sl_po = $(this).data('position');
			this_sl.slider({
				orientation: 	sl_po,
				range: 			'min',
				value: 			sl_va,
				min: 			sl_mi,
				max: 			sl_ma,
				step: 			sl_st,
				slide:	function( event, ui ) {
					$( '.wpcc_jq_slider_text', this_parent ).val( ui.value );
				},
				stop:	function( event, ui ) {
					wpcc_fn_action(ui.value, fid, wpcc_id);
				}
			});
			$( '.wpcc_jq_slider_text', this_parent ).on('blur', function() {
				if($(this).val() < sl_mi)
				{
					var input_slider_val = sl_mi;
				}
				else if($(this).val() > sl_ma)
				{
					var input_slider_val = sl_ma;
				}
				else
				{
					var input_slider_val = $(this).val();
				}
				$('.wpcc_jq_slider_box', this_parent).slider( "value", input_slider_val );
				$(this).val(input_slider_val);
				wpcc_fn_action(input_slider_val, fid, wpcc_id);
			});
		});
	}
	$('.wpcc_jq_slider').wpcc_slider();
	
	/* WPCC Validation */
	$.fn.wpcc_validation = function () {
		$(this).each(function() {
			$(this).bind("change keyup input click", function() {
				var this_val = $(this).val();
				
				if($(this).data('validation') == 'only_numbers_one_dot')
				{
					this_new_val = this_val.replace(/[^0-9.]/g, '');
					
					if(this_new_val.match(/\./g)) {
						this_count_dot = this_new_val.match(/\./g).length;
						if(this_count_dot > 1)
						{
							this_new_val = this_new_val.substr(0, this_new_val.lastIndexOf('.'));
						}
						if(this_new_val[0] == '.')
						{
							this_new_val = '0' + this_new_val;
						}
					}					
				}
				else if($(this).data('validation') == 'only_numbers')
				{
					this_new_val = this_val.replace(/[^0-9]/g, '');
				}
				if(this_val != this_new_val)
				{
					$(this).val(this_new_val);
				}
				
			});
		});
	};
	$('.wpcc_jq_validation').wpcc_validation();

	/* Send Calc */
	$('.wpcc_form .wpcc_submit').live('click', function() {
		var wpcc_parent = $(this).closest('.wpcc');
		var wpcc_form 	= $(this).closest('form');
		var wpcc_id 	= $('.wpcc_id', wpcc_form).val();
		var wpcc_autos 	= $('.wpcc_id', wpcc_form).data('autoscroll');
		var wpcc_action = $('.wpcc_action', wpcc_form).val();
		
		if(wpcc_action > 0)
		{
			var wpcc_post = wpcc_url + '/action/wpcc_load.php';
		}
		else
		{
			var wpcc_post = wpcc_url + '/action/wpcc_result.php';
		}
		
		$('.wpcc_loading div', wpcc_form).show();
		$.post(
			wpcc_post,
			wpcc_form.serialize(),
			function(data){
				if(wpcc_action > 0)
				{
					wpcc_parent.html(data);
				}
				else
				{
					$('.wpcc_result_block_' + wpcc_id).html(data);
					if(wpcc_autos == 'y')
					{
						$('html,body').animate({
							scrollTop: $('.wpcc_result_block_' + wpcc_id).offset().top
						}, 800);
					}
				}
				$('.wpcc_loading div', wpcc_form).hide();
			}
		);
		return false;
	});
	
	/* Send Mail */
	$('.wpcc_mail .wpcc_submit').live('click', function() {
		var wpcc_this_p = $(this).closest('form');
		var wpcc_id 	= $('.wpcc_mail_id', wpcc_this_p).val();
		$('.wpcc_loading div', wpcc_this_p).show();
		$.post(
			wpcc_url + '/action/wpcc_mail.php',
			wpcc_this_p.serialize(),
			function(jdata){
				var data = JSON.parse ( jdata );
				
				if(data.error != null && data.error != '')
				{
					$('.wpcc_mail_' + wpcc_id + ' .wpcc_error').html(data.error);
				}
				else
				{
					$('.wpcc_result_block_' + wpcc_id).html(data.success);
				}
				$('.wpcc_loading div', wpcc_this_p).hide();
			}
		);
		return false;
	});
	
});