jQuery(document).ready(function( $ ) {

	wpcc_url 	= $('.jq_wpcc_setting').data('plugin_url');
	wpcc_id 	= $('.jq_wpcc_setting').data('wpcc_id');
		
	/* Row Setting */
	$('.wpcc_fields li .ico').click( function() {
		var this_parent = $(this).closest('li');
		$(this).toggleClass('ico_active');
		$('.setting', this_parent).slideToggle();
	});
	
	/* Sortable */
	$(".wpcc_fields_sortable ul").sortable({
		opacity: 0.8,
		cursor: 'move',
		update: function() {
			$('.jq_wpcc_sortable').val($(this).sortable("toArray"));
		}							  
	});
	
	/* Toggle */
	$(".wpcc_js_toggle").live('click', function() {
		var this_data = $(this).data('container');
		$('.' + this_data).slideToggle();
	});
	
	/* Farbtastic Row ADM */
	$.fn.wpcc_color_picker = function () {
		$(this).each(function() {
			$(this).wpColorPicker({
				defaultColor: '#f7f7f7',
				change: function(event, ui){
					$(this).closest('li').css('background-color', ui.color.toString());
				},
				clear: function() {},
				hide: true,
				palettes: true
			});
		});
	};
	$('.jq_color_picker').wpcc_color_picker();
	
});